package cn.iocoder.yudao.module.iot.service.mqttdatarecord;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.module.iot.controller.admin.mqttdatarecord.vo.MqttDataRecordPageReqVO;
import cn.iocoder.yudao.module.iot.controller.admin.mqttdatarecord.vo.MqttDataRecordSaveReqVO;
import cn.iocoder.yudao.module.iot.dal.dataobject.mqttdatarecord.MqttDataRecordDO;
import cn.iocoder.yudao.module.iot.dal.mysql.mqttdatarecord.MqttDataRecordMapper;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.iot.enums.ErrorCodeConstants.MQTT_DATA_RECORD_NOT_EXISTS;

/**
 * 设备数据记录 Service 实现类
 *
 * @author 内蒙必硕
 */
@Service
@Validated
public class MqttDataRecordServiceImpl implements MqttDataRecordService {

    @Resource
    private MqttDataRecordMapper mqttDataRecordMapper;

    @Override
    public Long createMqttDataRecord(MqttDataRecordSaveReqVO createReqVO) {
        // 插入
        MqttDataRecordDO mqttDataRecord = BeanUtils.toBean(createReqVO, MqttDataRecordDO.class);
        mqttDataRecordMapper.insert(mqttDataRecord);
        // 返回
        return mqttDataRecord.getId();
    }

    @Override
    public void updateMqttDataRecord(MqttDataRecordSaveReqVO updateReqVO) {
        // 校验存在
        validateMqttDataRecordExists(updateReqVO.getId());
        // 更新
        MqttDataRecordDO updateObj = BeanUtils.toBean(updateReqVO, MqttDataRecordDO.class);
        mqttDataRecordMapper.updateById(updateObj);
    }

    @Override
    public void deleteMqttDataRecord(Long id) {
        // 校验存在
        validateMqttDataRecordExists(id);
        // 删除
        mqttDataRecordMapper.deleteById(id);
    }

    private void validateMqttDataRecordExists(Long id) {
        if (mqttDataRecordMapper.selectById(id) == null) {
            throw exception(MQTT_DATA_RECORD_NOT_EXISTS);
        }
    }

    @Override
    public MqttDataRecordDO getMqttDataRecord(Long id) {
        return mqttDataRecordMapper.selectById(id);
    }

    @Override
    public PageResult<MqttDataRecordDO> getMqttDataRecordPage(MqttDataRecordPageReqVO pageReqVO) {
        return mqttDataRecordMapper.selectPage(pageReqVO);
    }
    @Override
    public PageResult<MqttDataRecordDO> getMqttDataRecordPage2(MqttDataRecordPageReqVO pageReqVO) {
        return mqttDataRecordMapper.selectPage2(pageReqVO);
    }
}